/***************************************************************************
                          Solution.cpp  -  description
                             -------------------
    begin                : Fri Mar 21 2003
    copyright            : (C) 2003 by Christian Blum
    email                : cblum@ulb.ac.be
 ***************************************************************************/

/***************************************************************************
    Program's name: hc-mmas-ubqp

    Ant Colony Optimization algorithm to tackle 
    Unary Binary Quadratic Programming

    Copyright (C) 2003  Christian Blum

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's contact details: 

    email: cblum@ulb.ac.be
    mail address: Universite Libre de Bruxelles, IRIDIA,
                  Av. Franklin Roosevelt 50, CP 194/6,
                  B-1050 Brussels, Belgium

 ***************************************************************************/

#include "Solution.h"

Solution::Solution(){
  
  quality = 0.0;
}

Solution::~Solution(){
}

bool Solution::equals(vector<int> aSol) {

  bool result = true;
  for (int i = 0; ((i < solution.size()) && (result)); i++) {
    if (solution[i] != aSol[i]) {
      result = false;
    }
  }
  return result;
}

bool Solution::equals(Solution* aSol) {

  bool result = true;
  for (int i = 0; i < solution.size(); i++) {
    if (solution[i] != (aSol->solution)[i]) {
      result = false;
    }
  }
  return result;
}

Solution* Solution::copy() {

  Solution* newSol = new Solution();
  newSol->quality = quality;
  newSol->solution = solution;
  return newSol;
}
