/***************************************************************************
                          Unconstrained_Ant.h  -  description
                             -------------------
    begin                : Fri Jun 21 2002
    copyright            : (C) 2002 by Christian Blum
    email                : cblum@ulb.ac.be
 ***************************************************************************/

/***************************************************************************
    Program's name: hc-mmas-ubqp

    Ant Colony Optimization algorithm to tackle 
    Unary Binary Quadratic Programming

    Copyright (C) 2003  Christian Blum

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's contact details: 

    email: cblum@ulb.ac.be
    mail address: Universite Libre de Bruxelles, IRIDIA,
                  Av. Franklin Roosevelt 50, CP 194/6,
                  B-1050 Brussels, Belgium

 ***************************************************************************/

#ifndef UNCONSTRAINED_ANT_H
#define UNCONSTRAINED_ANT_H

#include "config.h"

#include "Random.h"
#include "Solution.h"
#include <vector>
#include <map>
#include <string>
#include <math.h>

/**
  *@author Christian Blum
  */

class Unconstrained_Ant {
public: 
	Unconstrained_Ant(int ps, Random* ri, map<int,pair<double,double> >* pi, double** qm, double cc, bool ls);
	~Unconstrained_Ant();
	
	int problem_size;
	vector<int> current_solution;
	vector<int> positives;
	Solution* constructed_solution;
	map<int,pair<double,double> >* pheromone;
    	Random* r_number;
	double** q_matrix;
	double c_const;
	bool ls_usage;

	void construct();
	void evaluate();
	void localsearch();

private:

	double solutionQuality();

};

#endif
