/***************************************************************************
                          utilstuff.cpp  -  description
                             -------------------
    begin                : Mon Jan 21 2001
    copyright            : (C) 2000 by Christian Blum
    email                : cblum@ulb.ac.be
 ***************************************************************************/

/***************************************************************************
    Program's name: hc-mmas-ubqp

    Ant Colony Optimization algorithm to tackle 
    Unary Binary Quadratic Programming

    Copyright (C) 2003  Christian Blum

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's contact details: 

    email: cblum@ulb.ac.be
    mail address: Universite Libre de Bruxelles, IRIDIA,
                  Av. Franklin Roosevelt 50, CP 194/6,
                  B-1050 Brussels, Belgium

 ***************************************************************************/

#include "utilstuff.h"

double ** DoubleMatrixAlloc(int nrows, int ncol)
{
  double **matrix;

  if ((matrix=(double**) malloc(sizeof(double)*nrows*ncol + sizeof(double*)*nrows)) == NULL){
    printf("Memory allocation error");
    exit(1);
  }

  for (int r=0; r<nrows; r++){
    matrix[r] = (double *) (matrix+nrows)+r*ncol;
  }

  return matrix;
}

int ** IntMatrixAlloc(int nrows, int ncol)
{
  int **matrix;

  if ((matrix=(int**) malloc(sizeof(int)*nrows*ncol + sizeof(int*)*nrows)) == NULL){
    printf("Memory allocation error");
    exit(1);
  }

  for (int r=0; r<nrows; r++){
    matrix[r] = (int *) (matrix+nrows)+r*ncol;
  }

  return matrix;
}

long int ** LongIntMatrixAlloc(int nrows, int ncol)
{
  long int **matrix;

  if ((matrix=(long int**) malloc(sizeof(long int)*nrows*ncol + sizeof(long int*)*nrows)) == NULL){
    printf("Memory allocation error");
    exit(1);
  }

  for (int r=0; r<nrows; r++){
    matrix[r] = (long int *) (matrix+nrows)+r*ncol;
  }

  return matrix;
}

long int* LongIntVectorAlloc(int n) {

  long int* v = (long int*) malloc( n * sizeof(long int) );
  return v;
}

int* IntVectorAlloc(int n) {

  int* v = (int*) malloc( n * sizeof(int) );
  return v;
}

double* DoubleVectorAlloc(int n) {

  double* v = (double*) malloc( n * sizeof(double));
  return v;
}

